%global alignak_user nagios
%global alignak_group nagios

Summary:        Alignak is a monitoring framework compatible with Nagios
License:        AGPLv3+
Name:           alignak
Version:        1.0
Release:        1%{?dist}
URL:            https://github.com/Alignak-monitoring/%{name}
Source0:        https://github.com/Alignak-monitoring/%{name}/archive/%{version}.tar.gz 
Source1:        %{name}-arbiter.service 
Source2:        %{name}-broker.service 
Source3:        %{name}-reactionner.service 
Source4:        %{name}-receiver.service 
Source5:        %{name}-poller.service 
Source6:        %{name}-scheduler.service 
Source7:        %{name}.logrotate
Source8:        %{name}-tmpfiles.conf 
Source9:        %{name}-arbiter.8alignak
Source10:        %{name}-broker.8alignak
Source11:        %{name}-poller.8alignak
Source12:        %{name}-reactionner.8alignak
Source13:        %{name}-receiver.8alignak
Source14:        %{name}-scheduler.8alignak
Requires:       python-simplejson 
Requires:       python-pycurl  
Requires:       python-cherrypy 
Requires:       python-requests >= 2.7.0
Requires:       python-setproctitle
Requires:       python-importlib
Requires:       python2-pbr
Requires:       python-ujson
Requires:       python-termcolor
Requires:       python-numpy
Requires:       pyOpenSSL
Requires(post): systemd-units
Requires(preun): systemd-units
Requires(postun): systemd-units
BuildRequires:  python-devel
BuildRequires:  python-setuptools
BuildRequires:  python-pbr
BuildRequires:  systemd-units

BuildRoot:      %{_tmppath}/%{name}-%{version}-buildroot
Buildarch:      noarch

%description 
Presentation of the Alignak project Welcome to the Alignak project. Alignak
project is a monitoring framwork based on Shinken who tend to follow OpenStack
standards and integrate with it. Its main goal is to give users a flexible
architecture for their monitoring system that is designed to scale to large
environments.Alignak is backwardscompatible with the Nagios configuration
standard and ...

%package all
Summary: Meta-package to pull in all alignak 
Requires: %{name}-common = %{version}-%{release}
Requires: %{name}-arbiter = %{version}-%{release}
Requires: %{name}-broker = %{version}-%{release}
Requires: %{name}-scheduler = %{version}-%{release}
Requires: %{name}-reactionner = %{version}-%{release}
Requires: %{name}-receiver = %{version}-%{release}
Requires: %{name}-poller = %{version}-%{release}

%description all
 Alignak project is a monitoring framwork based on Shinken who tend to 
follow OpenStack standards and integrate with it. Its main goal is to 
give users a flexible architecture for their monitoring system that is 
designed to scale to large environments.

This is a dummy package which brings in all subpackages.

%package common
Summary: Alignak Common 

%description common
Alignak Common

%package arbiter
Summary: Alignak Arbiter 
Requires: %{name}-common = %{version}-%{release}

%description arbiter
Alignak arbiter daemon

%package reactionner
Summary: Alignak Reactionner
Requires: %{name}-common = %{version}-%{release}

%description reactionner
Alignak reactionner daemon

%package scheduler
Summary: Alignak Scheduler
Requires: %{name}-common = %{version}-%{release}

%description scheduler
Alignak scheduler daemon

%package poller
Summary: Alignak Poller
Requires: %{name}-common = %{version}-%{release}
Requires: nagios-plugins-all

%description poller
Alignak poller daemon

%package broker
Summary: Alignak Broker
Requires: %{name}-common = %{version}-%{release}

%description broker
Alignak broker daemon

%package receiver
Summary: Alignak Poller
Requires: %{name}-common = %{version}-%{release}

%description receiver
Alignak receiver daemon

%prep

%setup -q -n %{name}-%{version}

# clean git files/
find . -name '.gitignore' -exec rm -f {} \;
find . -name '.gitempty' -exec rm -f {} \;
find . -name '.gitkeep' -exec rm -f {} \;

%build

%py2_build

%install

find %{buildroot} -size 0 -delete

%py2_install

install -d -m0755 %{buildroot}%{_unitdir}
install -p -m0644 %{SOURCE1} %{buildroot}%{_unitdir}/%{name}-arbiter.service
install -p -m0644 %{SOURCE2} %{buildroot}%{_unitdir}/%{name}-broker.service
install -p -m0644 %{SOURCE3} %{buildroot}%{_unitdir}/%{name}-reactionner.service
install -p -m0644 %{SOURCE4} %{buildroot}%{_unitdir}/%{name}-receiver.service
install -p -m0644 %{SOURCE5} %{buildroot}%{_unitdir}/%{name}-poller.service
install -p -m0644 %{SOURCE6} %{buildroot}%{_unitdir}/%{name}-scheduler.service

rm -rf %{buildroot}/usr/etc/%{name}/*
rm -rf %{buildroot}/usr/etc/default/%{name}

install -d -m0755 %{buildroot}%{_sysconfdir}/%{name}
install -d -m0755 %{buildroot}%{_sysconfdir}/%{name}/daemons
install -p -m0644 etc/daemons/arbiterd.ini %{buildroot}%{_sysconfdir}/%{name}/daemons/arbiterd.ini
install -p -m0644 etc/daemons/brokerd.ini %{buildroot}%{_sysconfdir}/%{name}/daemons/brokerd.ini
install -p -m0644 etc/daemons/pollerd.ini %{buildroot}%{_sysconfdir}/%{name}/daemons/pollerd.ini
install -p -m0644 etc/daemons/reactionnerd.ini %{buildroot}%{_sysconfdir}/%{name}/daemons/reactionnerd.ini
install -p -m0644 etc/daemons/receiverd.ini %{buildroot}%{_sysconfdir}/%{name}/daemons/receiverd.ini
install -p -m0644 etc/daemons/schedulerd.ini %{buildroot}%{_sysconfdir}/%{name}/daemons/schedulerd.ini

install -p -m0644 etc/alignak.cfg %{buildroot}%{_sysconfdir}/%{name}/alignak.cfg

cp -rf etc/{certs,arbiter} %{buildroot}%{_sysconfdir}/%{name}

rm -rf %{buildroot}%{_sysconfdir}/%{name}/sample
install -d -m0755 %{buildroot}%{_sysconfdir}/%{name}/modules

install -d -m0755 %{buildroot}%{_sysconfdir}/logrotate.d
install -p -m0644 %{SOURCE7} %{buildroot}%{_sysconfdir}/logrotate.d/%{name}

install -d -m0755 %{buildroot}%{_sysconfdir}/tmpfiles.d
install -m0644  %{SOURCE8} %{buildroot}%{_sysconfdir}/tmpfiles.d/%{name}.conf

install -d -m0755 %{buildroot}%{_localstatedir}/log/%{name}
install -d -m0755 %{buildroot}%{_localstatedir}/log/%{name}/archives
install -d -m0755 %{buildroot}%{_localstatedir}/lib/%{name}

mkdir -p %{buildroot}%{_localstatedir}/run/
install -d -m0755 %{buildroot}%{_localstatedir}/run/%{name}

install -d -m0755 %{buildroot}%{_mandir}/man8
install -p -m0644 %{SOURCE9} %{buildroot}%{_mandir}/man8
install -p -m0644 %{SOURCE10} %{buildroot}%{_mandir}/man8
install -p -m0644 %{SOURCE11} %{buildroot}%{_mandir}/man8
install -p -m0644 %{SOURCE12} %{buildroot}%{_mandir}/man8
install -p -m0644 %{SOURCE13} %{buildroot}%{_mandir}/man8
install -p -m0644 %{SOURCE14} %{buildroot}%{_mandir}/man8

rm -rf %{buildroot}/usr/etc/init.d/*

%clean

%pre 
getent group %{alignak_group} >/dev/null || groupadd -r %{alignak_group}
getent passwd %{alignak_user} >/dev/null || useradd -r -g %{alignak_group} -d %{_localstatedir}/spool/nagios -s /sbin/nologin %{alignak_user}
exit 0

%post arbiter
if [ $1 -eq 1 ] ; then 
  /bin/systemctl daemon-reload >/dev/null 2>&1 || :
fi

%post broker
if [ $1 -eq 1 ] ; then 
  /bin/systemctl daemon-reload >/dev/null 2>&1 || :
fi

%post poller
if [ $1 -eq 1 ] ; then 
  /bin/systemctl daemon-reload >/dev/null 2>&1 || :
fi

%post reactionner
if [ $1 -eq 1 ] ; then 
  /bin/systemctl daemon-reload >/dev/null 2>&1 || :
fi

%post scheduler
if [ $1 -eq 1 ] ; then 
  /bin/systemctl daemon-reload >/dev/null 2>&1 || :
fi

%post receiver
if [ $1 -eq 1 ] ; then 
  /bin/systemctl daemon-reload >/dev/null 2>&1 || :
fi

%preun arbiter 
if [ $1 -eq 0 ] ; then
  /bin/systemctl --no-reload disable %{name}-arbiter.service > /dev/null 2>&1 || :
  /bin/systemctl stop %{name}-arbiter.service > /dev/null 2>&1 || :
fi

%preun broker 
if [ $1 -eq 0 ] ; then
  /bin/systemctl --no-reload disable %{name}-broker.service > /dev/null 2>&1 || :
  /bin/systemctl stop %{name}-broker.service > /dev/null 2>&1 || :
fi

%preun poller 
if [ $1 -eq 0 ] ; then
  /bin/systemctl --no-reload disable %{name}-poller.service > /dev/null 2>&1 || :
  /bin/systemctl stop %{name}-poller.service > /dev/null 2>&1 || :
fi

%preun reactionner 
if [ $1 -eq 0 ] ; then
  /bin/systemctl --no-reload disable %{name}-reactionner.service > /dev/null 2>&1 || :
  /bin/systemctl stop %{name}-reactionner.service > /dev/null 2>&1 || :
fi

%preun scheduler 
if [ $1 -eq 0 ] ; then
  /bin/systemctl --no-reload disable %{name}-scheduler.service > /dev/null 2>&1 || :
  /bin/systemctl stop %{name}-scheduler.service > /dev/null 2>&1 || :
fi

%preun receiver 
if [ $1 -eq 0 ] ; then
  /bin/systemctl --no-reload disable %{name}-receiver.service > /dev/null 2>&1 || :
  /bin/systemctl stop %{name}-receiver.service > /dev/null 2>&1 || :
fi

%postun arbiter
/bin/systemctl daemon-reload >/dev/null 2>&1 || :
if [ $1 -ge 1 ] ; then
  /bin/systemctl try-restart %{name}-arbiter.service >/dev/null 2>&1 || :
fi

%postun broker
/bin/systemctl daemon-reload >/dev/null 2>&1 || :
if [ $1 -ge 1 ] ; then
  /bin/systemctl try-restart %{name}-broker.service >/dev/null 2>&1 || :
fi

%postun poller
/bin/systemctl daemon-reload >/dev/null 2>&1 || :
if [ $1 -ge 1 ] ; then
  /bin/systemctl try-restart %{name}-poller.service >/dev/null 2>&1 || :
fi

%postun reactionner
/bin/systemctl daemon-reload >/dev/null 2>&1 || :
if [ $1 -ge 1 ] ; then
  /bin/systemctl try-restart %{name}-reactionner.service >/dev/null 2>&1 || :
fi

%postun scheduler
/bin/systemctl daemon-reload >/dev/null 2>&1 || :
if [ $1 -ge 1 ] ; then
  /bin/systemctl try-restart %{name}-scheduler.service >/dev/null 2>&1 || :
fi

%postun receiver
/bin/systemctl daemon-reload >/dev/null 2>&1 || :
if [ $1 -ge 1 ] ; then
  /bin/systemctl try-restart %{name}-receiver.service >/dev/null 2>&1 || :
fi

%files arbiter
%{_unitdir}/%{name}-arbiter.service
%{_bindir}/%{name}-arbiter*
%{_mandir}/man8/%{name}-arbiter*
%config(noreplace) %{_sysconfdir}/%{name}/arbiter
%config(noreplace) %{_sysconfdir}/%{name}/daemons/arbiterd.ini
%config(noreplace) %{_sysconfdir}/%{name}/%{name}.cfg
%config(noreplace) %{_sysconfdir}/%{name}/certs

%files reactionner
%{_unitdir}/%{name}-reactionner.service
%{_bindir}/%{name}-reactionner*
%{_mandir}/man8/%{name}-reactionner*
%config(noreplace) %{_sysconfdir}/%{name}/daemons/reactionnerd.ini

%files scheduler
%{_unitdir}/%{name}-scheduler.service
%{_bindir}/%{name}-scheduler*
%{_mandir}/man8/%{name}-scheduler*
%config(noreplace) %{_sysconfdir}/%{name}/daemons/schedulerd.ini

%files poller
%{_unitdir}/%{name}-poller.service
%{_bindir}/%{name}-poller*
%{_mandir}/man8/%{name}-poller*
%config(noreplace) %{_sysconfdir}/%{name}/daemons/pollerd.ini

%files broker
%{_unitdir}/%{name}-broker.service
%{_bindir}/%{name}-broker*
%{_mandir}/man8/%{name}-broker*
%config(noreplace) %{_sysconfdir}/%{name}/daemons/brokerd.ini

%files receiver
%{_unitdir}/%{name}-receiver.service
%{_bindir}/%{name}-receiver*
%{_mandir}/man8/%{name}-receiver*
%config(noreplace) %{_sysconfdir}/%{name}/daemons/receiverd.ini

%files common
%{python_sitelib}/%{name}
%{python_sitelib}/alignak*.egg-info
%doc COPYING THANKS 
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%config(noreplace) %{_sysconfdir}/tmpfiles.d/%{name}.conf
%attr(-,%{alignak_user} ,%{alignak_group}) %dir %{_localstatedir}/log/%{name}
%attr(-,%{alignak_user} ,%{alignak_group}) %{_localstatedir}/lib/%{name}
%attr(-,%{alignak_user} ,%{alignak_group}) %dir %{_localstatedir}/run/%{name}

%files all
# No files for you!

%changelog
* Sun Mar 26 2017 David Hannequin <david.hannequin@gmail.com> - 1.0-1
- Initial release for Fedora.
